Index: lib/TWiki/UI/RDiff.pm
===================================================================
--- lib/TWiki/UI/RDiff.pm	(revision 3728)
+++ lib/TWiki/UI/RDiff.pm	(working copy)
@@ -309,7 +309,7 @@
     my $rev2 = $query->param( "rev2" );
 
     $renderStyle = "sequential" if ( ! $renderStyle );
-    $diffType = "history" if ( ! $diffType );
+    $diffType = "diff" if ( ! $diffType );
     $contextLines = 3 unless ( defined $contextLines );
 
     TWiki::UI::checkWebExists( $session, $webName, $topic );
@@ -321,16 +321,15 @@
     my $j = $maxrev;
     my $revTitle1 = "";
     my $revTitle2 = "";
-    my $revInfo1 = "";
-    my $revInfo2 = "";
+    my $revInfo = "";
     my $isMultipleDiff = 0;
-    my( $before, $difftmpl, $after);
+    my( $before, $difftmpl, $after, $tail);
     my $topicExists;
 
     $tmpl = $session->{templates}->readTemplate( "rdiff", $skin );
     $tmpl =~ s/\%META{.*?}\%//go;  # remove %META{"parent"}%
 
-    ( $before, $difftmpl, $after) = split( /%REPEAT%/, $tmpl);
+    ( $before, $difftmpl, $after, $tail) = split( /%REPEAT%/, $tmpl);
 
     $topicExists = $session->{store}->topicExists( $webName, $topic );
     if( $topicExists ) {
@@ -349,10 +348,8 @@
             $rev2 = $maxrev-1;
         }
         $revTitle1 = $rev1;
-        $revInfo1 = $session->{renderer}->renderRevisionInfo( $webName, $topic, $rev1, undef );
         if( $rev1 != $rev2 ) {
             $revTitle2 = $rev2;
-            $revInfo2 = $session->{renderer}->renderRevisionInfo( $webName, $topic, $rev2, undef );
         }
     } else {
         $rev1 = 1;
@@ -379,7 +376,7 @@
         }
         do {
             $diff = $difftmpl;
-            $diff =~ s/%REVTITLE1%/r1\.$r1/go;
+            $diff =~ s/%REVTITLE1%/$r1/go;
             $rInfo = $session->{renderer}->renderRevisionInfo( $webName, $topic, $r1, "\$date - \$wikiusername" );
             # eliminate white space to prevent wrap around in HR table:
             $rInfo =~ s/\s+/&nbsp;/g;
@@ -439,13 +436,22 @@
         }
         $i = $i - 1;
     }
+
+    $i = $rev1;
+    my $tailResult = "";
+    my $revTitle   = "";
+    while( $i >= $rev2) {
+	$revTitle = "<a href=\"$session->{scriptUrlPath}/view%SCRIPTSUFFIX%/%WEB%/%TOPIC%?rev=$i\" $TWiki::cfg{NoFollow}>$i</a>";
+	$revInfo = $session->{renderer}->renderRevisionInfo( $webName, $topic, $i, undef );
+	$tailResult .= $tail;
+	$tailResult =~ s/%REVTITLE%/$revTitle/go;
+	$tailResult =~ s/%REVINFO%/$revInfo/go;
+	$i = $i - 1;
+    }
+    $after =~ s/%TAIL%/$tailResult/go;
     $after =~ s/%REVISIONS%/$revisions/go;
     $after =~ s/%CURRREV%/$rev1/go;
     $after =~ s/%MAXREV%/$maxrev/go;
-    $after =~ s/%REVTITLE1%/$revTitle1/go;
-    $after =~ s/%REVINFO1%/$revInfo1/go;
-    $after =~ s/%REVTITLE2%/$revTitle2/go;
-    $after =~ s/%REVINFO2%/$revInfo2/go;
 
     $after = $session->handleCommonTags( $after, $webName, $topic );
     $after = $session->{renderer}->getRenderedVersion( $after, $webName, $topic );
Index: templates/rdiff.pattern.tmpl
===================================================================
--- templates/rdiff.pattern.tmpl	(revision 3728)
+++ templates/rdiff.pattern.tmpl	(working copy)
@@ -10,7 +10,7 @@
 
 %TMPL:DEF{"repeatedsearchblock"}%%REPEAT%<div class="twikiSearchResults"><div class="twikiSearchResultsHeader">&nbsp;<tt><b>&lt;&lt;O&gt;&gt;</b></tt>&nbsp; Difference Topic
       <b><a href="%SCRIPTURLPATH%/view%SCRIPTSUFFIX%/%WEB%/%TOPIC%">%TOPIC%</a></b>
-      (<a href="%SCRIPTURLPATH%/view%SCRIPTSUFFIX%/%WEB%/%TOPIC%?rev=%REVTITLE1%" %NOFOLLOW%>%REVTITLE1%</a> - %REVINFO1%)</div>
+      (<a href="%SCRIPTURLPATH%/view%SCRIPTSUFFIX%/%WEB%/%TOPIC%?rev=1.%REVTITLE1%" %NOFOLLOW%>%REVTITLE1%</a> - %REVINFO1%)</div>
 %TEXT%</div>%REPEAT%%TMPL:END%
 
 
@@ -36,5 +36,4 @@
 
 
 
-%TMPL:DEF{"topicinfo"}%<div class="twikiTopicInfo"><span class="twikiRevInfo twikiGrayText">Revision %REVTITLE2% - %REVINFO2%<br />
-Revision %REVTITLE1% - %REVINFO1%</span></div>%TMPL:END%
+%TMPL:DEF{"topicinfo"}%<div class="twikiTopicInfo"><span class="twikiRevInfo twikiGrayText">%TAIL%</span></div>%TMPL:END%%REPEAT%Revision %REVTITLE% - %REVINFO%<br />
Index: lib/TWiki/Plugins/DefaultPlugin.pm
===================================================================
--- lib/TWiki/Plugins/DefaultPlugin.pm	(revision 3728)
+++ lib/TWiki/Plugins/DefaultPlugin.pm	(working copy)
@@ -71,8 +71,8 @@
     # Old INCLUDE syntax
     if( $doOldInclude ) {
         # allow two level includes
-        $_[0] =~ s/%INCLUDE:"([^%\"]*?)"%/$TWiki::Plugins::SESSION->_INCLUDE( TWiki::extractParameters( $1 ), $_[1], $_[2], "" )/geo;
-        $_[0] =~ s/%INCLUDE:"([^%\"]*?)"%/$TWiki::Plugins::SESSION->_INCLUDE( TWiki::extractParameters( $1 ), $_[1], $_[2], "" )/geo;
+        $_[0] =~ s/%INCLUDE:"([^%\"]*?)"%/$TWiki::Plugins::SESSION->_INCLUDE( new TWiki::Attrs( ), $_[1], $_[2], "" )/geo;
+        $_[0] =~ s/%INCLUDE:"([^%\"]*?)"%/$TWiki::Plugins::SESSION->_INCLUDE( new TWiki::Attrs( ), $_[1], $_[2], "" )/geo;
     }
 
     ######################
